unit ERep;

//{$HINTS ON}
{$HINTS OFF}

interface

uses
	Windows, Messages, Controls, Classes, SysUtils, DsgnIntf, SEditProp,
  CommonType, DDEClient;

type

  //
  TOnSylkReportMessage = procedure(Sender: TObject; const iMessage, iW, iL: Integer) of object;

  //
  TOnReportError = procedure(Sender: TObject; var Msg: TMessage; var sStr: String) of object;
  TOnSectionDataRequestByCell = procedure(Sender: TObject; var RqData: DataRq) of object;
  TOnSectionDataRequestByVal = procedure(Sender: TObject; var iP: Longint; var sStr: String) of object;
  TOnSectionDataRequestByNum = procedure(Sender: TObject; var iP: Longint; var sStr: String) of object;
  TOnSectionDataRequestByName = procedure(Sender: TObject; var sFieldName: String; var sStr: String) of object;
  TOnCheck = procedure(Sender: TObject; var bCheck: Boolean) of object;
  //

  TERpt = class(TThread)
	private

    FCharByNum: Char;
    FCharByName: Char;
    FInputBlank: String;
    FOutputBlank: String;

    fhInBlank:          Integer;
    fhOutBlank:         Integer;
    uiSizeIn:           Integer;
    uiOutP:             Integer;
    ucpInBuff:          pChar;          //array [0..FILE_BUFFER-1] of Char;
    ucpOutBuff:         pChar;          //array [0..FILE_BUFFER-1] of char;
    uipLines:           array of Integer;
    uiInLines:          Integer;
    uipWidths:          array of Integer;
    uiInWidths:         Integer;
    uiDetail:           Integer;
    CurrRow:            Integer;
    CurrCol:            Integer;
    cFieldName:         String;
    bCheck:             Boolean;
    RequestStr:         String;
    FCurrentSection:    String;
    FCurrentSectionNum: Integer;
    stDataRq:           DataRq;
    FOnSylkReportMessage: TOnSylkReportMessage;
    FOutStream: TStream;
    FTypeDiraction: TTtypeDiraction;
    FLastDynSection: Integer;
    FLastDynSectionH: Integer;
    lWM_REP_SECTION_PREPARE: boolean;
    FTypeReport: TTtypeSylkReport;

    Sections:           array [0..MAX_SECTION_NUM] of Section;
    SectionsH:          array [0..MAX_SECTION_NUM] of Section;

    function ParseWidth(RegionD: PChar; var iMin, iMax, iWidth: Integer): Integer;

    procedure lpRepBegin;
    procedure lpRepBeginHorizontaly;
    procedure lpRepBeginBiDirection;
    procedure _OutSection(const bDefOut: Boolean; const SectionIndex: Integer);
    procedure _OutSectionHorizontaly(const bDefOut: Boolean; const SectionIndex: Integer);
    procedure _PrepareSection(var cSection: Section; const cSectionName: ShortString; const SectionIndex: Integer);
    procedure CloseSections;

    procedure OutChar(cc: Char);

    procedure SeekLastNN(var fppP: FoundPar);

    function RowsP(RegionD: pChar): Integer;
    function RowsPExact(RegionD: pChar): Integer;
    function pow10(i: Integer): Integer;

    function GetSectionName(iIndex: Integer): ShortString;
    function GetSectionNameH(iIndex: Integer): ShortString;

	protected

    procedure Execute(); override;

	public

    constructor Create;
    destructor Destroy; override;

    procedure ReportResume;
    procedure ReportExecute;
    procedure ReportHorizontalyResume;
    procedure ReportHorizontalyExecute;
    procedure BiDirectionResume;
    procedure BiDirectionExecute;

    function PrepareSection(const SectionName: ShortString): Integer;
    function PrepareHorizontalySection(const SectionName: ShortString): Integer;

    procedure OutSection(SectionName: ShortString);
    procedure OutHorizontalySection(SectionName: ShortString);
    procedure OutSectionByNum(SectionNum: Integer);
    procedure OutHorizontalySectionByNum(SectionNum: Integer);

    property TypeDiraction: TTtypeDiraction read FTypeDiraction write FTypeDiraction default tdVerticaly;
    property TypeReport: TTtypeSylkReport read FTypeReport;

    property InputBlank: String read FInputBlank write FInputBlank;
    property OutputBlank: String read FOutputBlank write FOutputBlank;
    property OutStream: TStream read FOutStream write FOutStream;
    property CharByNum: Char read FCharByNum write FCharByNum default Char(REQUEST_DATA_BY_NUM_SYMBOL); {&0001}
    property CharByName: Char read FCharByName write FCharByName default Char(REQUEST_DATA_BY_NAME_SYMBOL); {~name~}

    property OnSylkReportMessage: TOnSylkReportMessage read FOnSylkReportMessage write FOnSylkReportMessage;

    property SectionName[iIndex: Integer]: ShortString read GetSectionName;
    property SectionNameH[iIndex: Integer]: ShortString read GetSectionNameH;

  end;

  //
  TSylkStream = class(TComponent)
	private

		_Sylk: TERpt;
    FCharByName: Char;
    FCharByNum: Char;
    FOutputBlank: String;
    FInputBlank: String;
    FOnStartReport: TNotifyEvent;
    FOnSectionBegin: TNotifyEvent;
    FOnSectionPrepare: TNotifyEvent;
    FOnSectionEnd: TNotifyEvent;
    FOnSectionComplit: TNotifyEvent;
    FOnEndReport: TNotifyEvent;
    FOnMoveTop: TOnCheck;
    FOnMoveNext: TOnCheck;
    FOnSectionCheck: TOnCheck;
    FOnReportError: TOnReportError;
    FOnSectionDataRequestByCell: TOnSectionDataRequestByCell;
    FOnSectionDataRequestByVal: TOnSectionDataRequestByVal;
    FOnSectionDataRequestByName: TOnSectionDataRequestByName;
    FOnSectionDataRequestByNum: TOnSectionDataRequestByNum;
    FOutStream: TStream;

		cS: String;
    cFieldName: String;
		bCheck: Boolean;

    //Message handlers
		procedure MsgStartReport(var Msg: TMessage);
		procedure MsgEndReport(var Msg: TMessage);
		procedure MsgReportMove(var Msg: TMessage);
    procedure MsgReportError(var Msg: TMessage);
    //End message handlers

    procedure SectionHandler( var Msg: TMessage;
                              e0: TNotifyEvent;
                              e1: TOnCheck;
                              e5: TOnSectionDataRequestByCell;
                              e6: TOnSectionDataRequestByVal;
                              e2: TOnSectionDataRequestByNum;
                              e3: TOnSectionDataRequestByName;
                              e4: TNotifyEvent;
                              e7: TNotifyEvent);

    procedure DispatchSmartMessages(Sender: TObject; const iMessage, iW, iL: Integer);
    function GetCurrentSection: String;
    function GetTypeDiraction: TTtypeDiraction;
    function GetTypeReport: TTtypeSylkReport;
    procedure SetPropertys;
    function GetCurrentSectionNum: Integer;

	protected
	public

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure ReportResume;
    procedure ReportExecute;
    procedure ReportHorizontalyResume;
    procedure ReportHorizontalyExecute;
    procedure BiDirectionResume;
    procedure BiDirectionExecute;

    function PrepareSection(const SectionName: ShortString): Integer;
    function PrepareHorizontalySection(const SectionName: ShortString): Integer;

    procedure OutSection(SectionName: ShortString);
    procedure OutHorizontalySection(SectionName: ShortString);
    procedure OutSectionByNum(SectionNum: Integer);
    procedure OutHorizontalySectionByNum(SectionNum: Integer);

    property CurrentSection: String read GetCurrentSection;
    property CurrentSectionNum: Integer read GetCurrentSectionNum;

    property TypeDiraction: TTtypeDiraction read GetTypeDiraction;
    property TypeReport: TTtypeSylkReport read GetTypeReport;

    property OutStream: TStream read FOutStream write FOutStream;

  published

		//Properties
    property InputBlank: String read FInputBlank write FInputBlank;
    property OutputBlank: String read FOutputBlank write FOutputBlank;
    property CharByNum: Char read FCharByNum write FCharByNum default Char(REQUEST_DATA_BY_NUM_SYMBOL); {&0001}
    property CharByName: Char read FCharByName write FCharByName default Char(REQUEST_DATA_BY_NAME_SYMBOL); {~name~}

		//Events
    property OnStartReport: TNotifyEvent read FOnStartReport write FOnStartReport;
    property OnEndReport: TNotifyEvent read FOnEndReport write FOnEndReport;

    property OnMoveTop: TOnCheck read FOnMoveTop write FOnMoveTop;
    property OnMoveNext: TOnCheck read FOnMoveNext write FOnMoveNext;

    property OnReportError: TOnReportError read FOnReportError write FOnReportError;

    property OnSectionBegin: TNotifyEvent read FOnSectionBegin write FOnSectionBegin;
    property OnSectionCheck: TOnCheck read FOnSectionCheck write FOnSectionCheck;
    property OnSectionDataRequestByCell: TOnSectionDataRequestByCell read FOnSectionDataRequestByCell write FOnSectionDataRequestByCell;
    property OnSectionDataRequestByVal: TOnSectionDataRequestByVal read FOnSectionDataRequestByVal write FOnSectionDataRequestByVal;
    property OnSectionDataRequestByNum: TOnSectionDataRequestByNum read FOnSectionDataRequestByNum write FOnSectionDataRequestByNum;
    property OnSectionDataRequestByName: TOnSectionDataRequestByName read FOnSectionDataRequestByName write FOnSectionDataRequestByName;
    property OnSectionEnd: TNotifyEvent read FOnSectionEnd write FOnSectionEnd;
    property OnSectionComplit: TNotifyEvent read FOnSectionComplit write FOnSectionComplit;

    property OnSectionPrepare: TNotifyEvent read FOnSectionPrepare write FOnSectionPrepare;

  end;

function GetTmpFileName: String;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('VK Reports', [TSylkStream]);
  RegisterPropertyEditor(TypeInfo(String), TSylkStream, 'InputBlank', TEdOpenBlank);
  RegisterPropertyEditor(TypeInfo(String), TSylkStream, 'OutputBlank', TEdSaveBlank);
end;

function GetTmpFileName: String;
var
  cpBufferPath: pChar;
  cpBufferTmpFile: pChar;
  i: Integer;
begin

  cpBufferPath := StrAlloc(MAX_PATH + 1);
  FillChar(cpBufferPath^, MAX_PATH + 1, 0);

  cpBufferTmpFile := StrAlloc(MAX_PATH + 1);
  FillChar(cpBufferTmpFile^, MAX_PATH + 1, 0);

  GetTempPath(MAX_PATH, cpBufferPath);

  for i := 0 to MAX_PATH - 1 do
  begin
    if Ord(cpBufferPath[i]) = 0 then break;
    if Ord(cpBufferPath[i]) <= 32 then
    begin
      cpBufferPath[i] := '\';
      cpBufferPath[i + 1] := #0;
      break;
    end;
  end;

  GetTempFileName(cpBufferPath, PChar(''), 0, cpBufferTmpFile);

  Result := Copy(cpBufferTmpFile, 1, Length(cpBufferTmpFile));

  StrDispose(cpBufferPath);
  StrDispose(cpBufferTmpFile);

end;

{ TERpt }

constructor TERpt.Create;
begin
  inherited Create(true);
  Priority := tpNormal;
  FreeOnTerminate := true;
  FOnSylkReportMessage := nil;
  FOutStream := nil;
  FCharByNum := Char(REQUEST_DATA_BY_NUM_SYMBOL);
  FCharByName := Char(REQUEST_DATA_BY_NAME_SYMBOL);
  FLastDynSection := 13;
  FLastDynSectionH := 13;
  lWM_REP_SECTION_PREPARE := false;
  ucpInBuff := StrAlloc(FILE_BUFFER);
  ucpOutBuff := StrAlloc(FILE_BUFFER);
end;

procedure TERpt.Execute;
begin
  case FTypeReport of
    tsrHorizontaly: lpRepBeginHorizontaly;
    tsrVerticaly  : lpRepBegin;
    tsrBiDirection: lpRepBeginBiDirection;
  end;
end;

function TERpt.GetSectionName(iIndex: Integer): ShortString;
begin
  Result := Sections[iIndex].Name;
end;

function TERpt.GetSectionNameH(iIndex: Integer): ShortString;
begin
  Result := SectionsH[iIndex].Name;
end;

procedure TERpt.OutSection(SectionName: ShortString);
var
  lEnd: boolean;
  i: Integer;
begin
  lEnd := FALSE;
  if ( SectionName = 'REPORTHEADER' ) then begin _OutSection(TRUE, 1); lEnd := TRUE; end;
  if ( SectionName = 'GROUPHEADER' ) then begin _OutSection(TRUE, 2); lEnd := TRUE; end;
  if ( SectionName = 'SUBGROUPHEADER' ) then begin _OutSection(TRUE, 3); lEnd := TRUE; end;
  if ( SectionName = 'SUBSUBGROUPHEADER' ) then begin _OutSection(TRUE, 4); lEnd := TRUE; end;
  if ( SectionName = 'SUPERSUBGROUPHEADER' ) then begin _OutSection(TRUE, 5); lEnd := TRUE; end;
  if ( SectionName = 'BODY' ) then begin _OutSection(TRUE, 6); lEnd := TRUE; end;
  if ( SectionName = 'SUPERSUBGROUPFOOTER' ) then begin _OutSection(TRUE, 7); lEnd := TRUE; end;
  if ( SectionName = 'SUBSUBGROUPFOOTER' ) then begin _OutSection(TRUE, 8); lEnd := TRUE; end;
  if ( SectionName = 'SUBGROUPFOOTER' ) then begin _OutSection(TRUE, 9); lEnd := TRUE; end;
  if ( SectionName = 'GROUPFOOTER' ) then begin _OutSection(TRUE, 10); lEnd := TRUE; end;
  if ( SectionName = 'REPORTFOOTER' ) then begin _OutSection(TRUE, 11); lEnd := TRUE; end;
  if ( not lEnd ) then
  begin
    // if Section is a Dynamic.
    for i := 13 to MAX_SECTION_NUM - 1 do
    begin
      if ( SectionName = Sections[i].Name ) then
      begin
        _OutSection(TRUE, i);
        break;
      end;
    end;
  end;
end;

procedure TERpt.OutHorizontalySection(SectionName: ShortString);
var
  lEnd: boolean;
  i: Integer;
begin
  lEnd := FALSE;
  if ( SectionName = 'H_REPORTHEADER' ) then begin _OutSectionHorizontaly(TRUE, 1); lEnd := TRUE; end;
  if ( SectionName = 'H_GROUPHEADER' ) then begin _OutSectionHorizontaly(TRUE, 2); lEnd := TRUE; end;
  if ( SectionName = 'H_SUBGROUPHEADER' ) then begin _OutSectionHorizontaly(TRUE, 3); lEnd := TRUE; end;
  if ( SectionName = 'H_SUBSUBGROUPHEADER' ) then begin _OutSectionHorizontaly(TRUE, 4); lEnd := TRUE; end;
  if ( SectionName = 'H_SUPERSUBGROUPHEADER' ) then begin _OutSectionHorizontaly(TRUE, 5); lEnd := TRUE; end;
  if ( SectionName = 'H_BODY' ) then begin _OutSectionHorizontaly(TRUE, 6); lEnd := TRUE; end;
  if ( SectionName = 'H_SUPERSUBGROUPFOOTER' ) then begin _OutSectionHorizontaly(TRUE, 7); lEnd := TRUE; end;
  if ( SectionName = 'H_SUBSUBGROUPFOOTER' ) then begin _OutSectionHorizontaly(TRUE, 8); lEnd := TRUE; end;
  if ( SectionName = 'H_SUBGROUPFOOTER' ) then begin _OutSectionHorizontaly(TRUE, 9); lEnd := TRUE; end;
  if ( SectionName = 'H_GROUPFOOTER' ) then begin _OutSectionHorizontaly(TRUE, 10); lEnd := TRUE; end;
  if ( SectionName = 'H_REPORTFOOTER' ) then begin _OutSectionHorizontaly(TRUE, 11); lEnd := TRUE; end;
  if ( not lEnd ) then
  begin
    // if Section is a Dynamic.
    for i := 13 to MAX_SECTION_NUM - 1 do
    begin
      if ( SectionName = SectionsH[i].Name ) then
      begin
        _OutSectionHorizontaly(TRUE, i);
        break;
      end;
    end;
  end;
end;

function TERpt.PrepareSection(const SectionName: ShortString): Integer;
begin
  if FLastDynSection = MAX_SECTION_NUM then
  begin
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, 0);
    Raise Exception.Create('LIMIT_EXCEEDED');
  end;
  if not lWM_REP_SECTION_PREPARE then
  begin
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_ALLAGIAL_CALL, 0, 0);
    Raise Exception.Create('ALLAGIAL_CALL');
  end;
  Result := FLastDynSection;
  Inc(FLastDynSection);
  _PrepareSection(Sections[Result], SectionName, Result);
end;

function TERpt.PrepareHorizontalySection(const SectionName: ShortString): Integer;
begin
  if FLastDynSectionH = MAX_SECTION_NUM then
  begin
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, 0);
    Raise Exception.Create('LIMIT_EXCEEDED');
  end;
  if not lWM_REP_SECTION_PREPARE then
  begin
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_ALLAGIAL_CALL, 0, 0);
    Raise Exception.Create('ALLAGIAL_CALL');
  end;
  Result := FLastDynSectionH;
  Inc(FLastDynSectionH);
  _PrepareSection(SectionsH[Result], SectionName, Result);
end;

procedure TERpt.ReportResume;
begin
  FTypeReport := tsrVerticaly;
  Resume;
end;

procedure TERpt.ReportExecute;
begin
  FTypeReport := tsrVerticaly;
  Execute;
end;

procedure TERpt.ReportHorizontalyResume;
begin
  FTypeReport := tsrHorizontaly;
  Resume;
end;

procedure TERpt.ReportHorizontalyExecute;
begin
  FTypeReport := tsrHorizontaly;
  Execute;
end;

procedure TERpt.BiDirectionResume;
begin
  FTypeReport := tsrBiDirection;
  Resume;
end;

procedure TERpt.BiDirectionExecute;
begin
  FTypeReport := tsrBiDirection;
  Execute;
end;

procedure TERpt.lpRepBegin;
var
  CreateOK: boolean;
  uiI, uiJ, uiK, uiRW: Integer;
  fppP: FoundPar;
begin
  FTypeDiraction := tdVerticaly;
  FLastDynSection := 13;
  lWM_REP_SECTION_PREPARE := FALSE;
  for uiI := 0 to MAX_SECTION_NUM do
    Sections[uiI].ucUsed := false;
  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_START_REPORT, 0, 0);
  fhInBlank := FileOpen(InputBlank, fmOpenRead or fmShareDenyWrite);
  if fhInBlank > 0 then
  begin
    CreateOK := true;
    if not Assigned(FOutStream) then
    begin
      fhOutBlank := FileCreate(OutputBlank);
      CreateOK := (fhOutBlank > 0);
    end;
		if CreateOK then
    begin
      FileSeek(fhInBlank, 0, 0);
      uiSizeIn := FileRead(fhInBlank, ucpInBuff^, FILE_BUFFER);
      if uiSizeIn <> 0 then
      begin
        uiOutP := 0;
        uiI := 0;
        uiJ := 0;
        while uiI < uiSizeIn do
        begin
          if ( ucpInBuff[uiI] = #$0D ) then Inc(uiJ);
          Inc(uiI);
        end;
        uiInLines := uiJ;
        SetLength(uipLines, uiInLines);
        uiI := 0;
        uiJ := 0;
        uiK := 0;
        while uiI < uiSizeIn do
        begin
          if ( ucpInBuff[uiI] = #$0D ) then
          begin
            uipLines[uiJ] := uiK;
            Inc(uiJ);
            uiK := uiI + 2;
          end;
          Inc(uiI);
        end;
        SeekLastNN(fppP);
        if ( fppP.bF ) then
        begin

          Sections[0].Name := 'SYLKHEADER';
          Sections[0].BeginR := 0;
          Sections[0].EndR := 0;
          Sections[0].ucUsed := TRUE;

          _PrepareSection(Sections[1],  'REPORTHEADER', 1);
          _PrepareSection(Sections[2],  'GROUPHEADER', 2);
          _PrepareSection(Sections[3],  'SUBGROUPHEADER', 3);
          _PrepareSection(Sections[4],  'SUBSUBGROUPHEADER', 4);
          _PrepareSection(Sections[5],  'SUPERSUBGROUPHEADER', 5);
          _PrepareSection(Sections[6],  'BODY', 6);
          _PrepareSection(Sections[7],  'SUPERSUBGROUPFOOTER', 7);
          _PrepareSection(Sections[8],  'SUBSUBGROUPFOOTER', 8);
          _PrepareSection(Sections[9],  'SUBGROUPFOOTER', 9);
          _PrepareSection(Sections[10], 'GROUPFOOTER', 10);
          _PrepareSection(Sections[11], 'REPORTFOOTER', 11);

          Sections[12].Name := 'SYLKFOOTER';
          Sections[12].BeginR := 0;
          Sections[12].EndR := 0;
          Sections[12].ucUsed := TRUE;
          //
          CurrRow := 1;
          //
          _OutSection(TRUE, 0);

          lWM_REP_SECTION_PREPARE := TRUE;
          if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_SECTION_PREPARE, 0, 0);
          lWM_REP_SECTION_PREPARE := FALSE;

          _OutSection(TRUE, 1);
          uiJ := 1;
          bCheck := FALSE;
          if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_MOVE, uiJ, MOVE_TOP);
          while ( not bCheck ) do
          begin

            _OutSection(FALSE, 2);
            _OutSection(FALSE, 3);
            _OutSection(FALSE, 4);
            _OutSection(FALSE, 5);
            _OutSection(TRUE, 6);
            _OutSection(FALSE, 7);
            _OutSection(FALSE, 8);
            _OutSection(FALSE, 9);
            _OutSection(FALSE, 10);

            bCheck := FALSE;
            if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_MOVE, uiJ, MOVE_NEXT);
            Inc(uiJ);
          end;
          _OutSection(TRUE, 11);
          _OutSection(TRUE, 12);
          CloseSections;
          if ( uiOutP > 0 ) then
          begin
            if not Assigned(FOutStream) then
              uiRW := FileWrite(fhOutBlank, ucpOutBuff^, uiOutP)
            else
              uiRW := FOutStream.Write(ucpOutBuff^, uiOutP);
            if uiOutP <> uiRW then
            begin
              if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_WRITE_ERROR, 0, 0);
              raise Exception.Create('WRITE_EXCEPTION');
            end;
            uiOutP := 0;
          end;
        end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_SECTION_ERROR, 0, 0);
      end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      if not Assigned(FOutStream) then FileClose(fhOutBlank);
    end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_CREATE_ERROR, 0, 0);
    FileClose(fhInBlank);
  end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_OPEN_ERROR, 0, 0);
  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_END_REPORT, 0, 0);
end;

procedure TERpt.lpRepBeginHorizontaly;
var
  CreateOK: boolean;
  uiI, uiJ, uiK, uiRW: Integer;
  fppP: FoundPar;
  cc, cc0, cc1: Char;
begin
  FTypeDiraction := tdHorizontaly;
  FLastDynSectionH := 13;
  lWM_REP_SECTION_PREPARE := FALSE;
  for uiI := 0 to MAX_SECTION_NUM do
    SectionsH[uiI].ucUsed := false;
  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_START_REPORT, 0, 0);
  fhInBlank := FileOpen(InputBlank, fmOpenRead or fmShareDenyWrite);
  if fhInBlank > 0 then
  begin
    CreateOK := true;
    if not Assigned(FOutStream) then
    begin
      fhOutBlank := FileCreate(OutputBlank);
      CreateOK := (fhOutBlank > 0);
    end;
		if CreateOK then
    begin
      FileSeek(fhInBlank, 0, 0);
      uiSizeIn := FileRead(fhInBlank, ucpInBuff^, FILE_BUFFER);
      if uiSizeIn <> 0 then
      begin
        uiOutP := 0;
        uiI := 0;
        uiJ := 0;
        while uiI < uiSizeIn do
        begin
          if ( ucpInBuff[uiI] = #$0D ) then Inc(uiJ);
          Inc(uiI);
        end;
        uiInLines := uiJ;
        SetLength(uipLines, uiInLines);
        uiI := 0;
        uiJ := 0;
        uiK := 0;
        while uiI < uiSizeIn do
        begin
          if ( ucpInBuff[uiI] = #$0D ) then
          begin
            uipLines[uiJ] := uiK;
            Inc(uiJ);
            uiK := uiI + 2;
          end;
          Inc(uiI);
        end;
        uiJ := 0;
        for uiI := 0 to uiInLines - 1 do
        begin
          cc := ucpInBuff[uipLines[uiI]];
          cc0 := ucpInBuff[uipLines[uiI] + 1];
          cc1 := ucpInBuff[uipLines[uiI] + 2];
          if ( (cc = 'F') and (cc0 = ';') and (cc1 = 'W') ) then Inc(uiJ);
        end;
        uiInWidths := uiJ;
        SetLength(uipWidths, uiInWidths);
        uiJ := 0;
        for uiI := 0 to uiInLines - 1 do
        begin
          cc := ucpInBuff[uipLines[uiI]];
          cc0 := ucpInBuff[uipLines[uiI] + 1];
          cc1 := ucpInBuff[uipLines[uiI] + 2];
          if ( (cc = 'F') and (cc0 = ';') and (cc1 = 'W') ) then
          begin
            uipWidths[uiJ] := uiI;
            Inc(uiJ);
          end;
        end;
        SeekLastNN(fppP);
        if ( fppP.bF ) then
        begin

          SectionsH[0].Name := 'SYLKHEADER';
          SectionsH[0].BeginR := 0;
          SectionsH[0].EndR := 0;
          SectionsH[0].ucUsed := TRUE;

          _PrepareSection(SectionsH[1],  'H_REPORTHEADER', 1);
          _PrepareSection(SectionsH[2],  'H_GROUPHEADER', 2);
          _PrepareSection(SectionsH[3],  'H_SUBGROUPHEADER', 3);
          _PrepareSection(SectionsH[4],  'H_SUBSUBGROUPHEADER', 4);
          _PrepareSection(SectionsH[5],  'H_SUPERSUBGROUPHEADER', 5);
          _PrepareSection(SectionsH[6],  'H_BODY', 6);
          _PrepareSection(SectionsH[7],  'H_SUPERSUBGROUPFOOTER', 7);
          _PrepareSection(SectionsH[8],  'H_SUBSUBGROUPFOOTER', 8);
          _PrepareSection(SectionsH[9],  'H_SUBGROUPFOOTER', 9);
          _PrepareSection(SectionsH[10], 'H_GROUPFOOTER', 10);
          _PrepareSection(SectionsH[11], 'H_REPORTFOOTER', 11);

          SectionsH[12].Name := 'SYLKFOOTER';
          SectionsH[12].BeginR := 0;
          SectionsH[12].EndR := 0;
          SectionsH[12].ucUsed := TRUE;
          //
          CurrCol := 1;
          //
          _OutSectionHorizontaly(TRUE, 0);

          lWM_REP_SECTION_PREPARE := TRUE;
          if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_SECTION_PREPARE, 0, 0);
          lWM_REP_SECTION_PREPARE := FALSE;

          _OutSectionHorizontaly(TRUE, 1);
          uiJ := 1;
          bCheck := FALSE;
          if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_MOVE, uiJ, MOVE_TOP);
          while ( not bCheck ) do
          begin

            _OutSectionHorizontaly(FALSE, 2);
            _OutSectionHorizontaly(FALSE, 3);
            _OutSectionHorizontaly(FALSE, 4);
            _OutSectionHorizontaly(FALSE, 5);
            _OutSectionHorizontaly(TRUE, 6);
            _OutSectionHorizontaly(FALSE, 7);
            _OutSectionHorizontaly(FALSE, 8);
            _OutSectionHorizontaly(FALSE, 9);
            _OutSectionHorizontaly(FALSE, 10);

            bCheck := FALSE;
            if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_MOVE, uiJ, MOVE_NEXT);
            Inc(uiJ);
          end;
          _OutSectionHorizontaly(TRUE, 11);
          _OutSectionHorizontaly(TRUE, 12);
          CloseSections;
          if ( uiOutP > 0 ) then
          begin
            if not Assigned(FOutStream) then
              uiRW := FileWrite(fhOutBlank, ucpOutBuff^, uiOutP)
            else
              uiRW := FOutStream.Write(ucpOutBuff^, uiOutP);
            if uiOutP <> uiRW then
            begin
              if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_WRITE_ERROR, 0, 0);
              raise Exception.Create('WRITE_EXCEPTION');
            end;
            uiOutP := 0;
          end;
        end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_SECTION_ERROR, 0, 0);
      end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      if not Assigned(FOutStream) then FileClose(fhOutBlank);
    end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_CREATE_ERROR, 0, 0);
    FileClose(fhInBlank);
  end else if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_OPEN_ERROR, 0, 0);
  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_END_REPORT, 0, 0);
end;

procedure TERpt.lpRepBeginBiDirection;
var
  cpTempFile: String;
  cpOldOut: String;
begin
  cpOldOut := OutputBlank;
  cpTempFile := GetTmpFileName;
  OutputBlank := cpTempFile;
  FTypeDiraction := tdHorizontaly;
  lpRepBeginHorizontaly;
  InputBlank := cpTempFile;
  OutputBlank := cpOldOut;
  FTypeDiraction := tdVerticaly;
  lpRepBegin;
  DeleteFile(cpTempFile);
end;

procedure TERpt._OutSection(const bDefOut: Boolean; const SectionIndex: Integer);
var
  uiI, uiDataIndex, i, j, stri, k: Integer;
  cI, cc, cc0, cc1, a0, a1, a2, a3: Char;
  yy, zz, cJ: Boolean;
  CurRow: Integer;
  OldCol, CurCol: Integer;
  b: array [0..19] of Char;
  kNum: Integer;
  LenRequestStr: Integer;
  q: Boolean;
  OldInd: Integer;
  OldName: String;
begin
  q := true;
  CurRow := 1;
  CurCol := 1;
  OldInd := FCurrentSectionNum;
  OldName := FCurrentSection;
  FCurrentSection := Sections[SectionIndex].Name;
  FCurrentSectionNum := SectionIndex;
  //
  try
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_BEGIN);
    if ( Sections[SectionIndex].ucUsed ) then
    begin
      bCheck := bDefOut;
      if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_CHECK);
      if ( SectionIndex = 0 ) then
      begin
        //
        for uiI:=0 to uiInLines - 1 do
        begin
          cc  := ucpInBuff[uipLines[uiI]];
          cc0 := ucpInBuff[uipLines[uiI] + 1];
          cc1 := ucpInBuff[uipLines[uiI] + 2];
          if ( ((cc <> 'F') and (cc <> 'C') and (cc <> 'E')) or ((cc = 'F') and (cc0 = ';') and (cc1 = 'W')) ) then
          begin
            stri := 0;
            while ( cc <> #$0D ) do
            begin
              OutChar(cc);
              Inc(stri);
              cc := ucpInBuff[uipLines[uiI] + stri];
            end;
            OutChar(#$0D);
            OutChar(#$0A);
          end;
        end;
        //
        bCheck := FALSE;
      end;
      if ( SectionIndex = 12 ) then
      begin
        //
        OutChar('E');
        OutChar(#$0D);
        OutChar(#$0A);
        //
        bCheck := FALSE;
      end;
      if ( bCheck ) then
      begin
        for uiI:=0 to uiInLines - 1 do
        begin
          //
          yy := FALSE;
          cc := ucpInBuff[uipLines[uiI]];
          if ( (cc = 'F') or (cc = 'C') ) then
          begin
            OldCol := CurCol;
            stri := 0;
            cc := ucpInBuff[uipLines[uiI]];
            cc0 := ucpInBuff[uipLines[uiI] + 1];
            while ( cc <> #$0D ) do
            begin
              if ( ((cc = ';') and (cc0 = 'R')) or ((cc = ';') and (cc0 = 'Y')) ) then
                CurRow := RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
              if ( ((cc = ';') and (cc0 = 'X')) ) then
                CurCol := RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
              Inc(stri);
              cc := ucpInBuff[uipLines[uiI] + stri];
              cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
            end;
            if ( ( Sections[SectionIndex].BeginR <= CurRow ) and ( CurRow <= Sections[SectionIndex].EndR ) ) then yy := TRUE;
          end;
          //
          zz := FALSE;
          if ( yy ) then
          begin
            if (OldCol = CurCol) and q then begin
              OutChar('F');
              OutChar(';');
              OutChar('X');
              //
              StrFmt(b, PChar('%d'), [CurCol]);
              k := 0;
              while ( b[k] > #0 ) do
              begin
                OutChar(b[k]);
                Inc(k);
              end;
              //
              OutChar(#$0D);
              OutChar(#$0A);
              q := false;
            end;
            stri := 0;
            cc := ucpInBuff[uipLines[uiI]];
            cc0 := ucpInBuff[uipLines[uiI] + 1];
            while ( cc <> #$0D ) do
            begin
              if ( (cc = ';') and (cc0 = 'X') ) then zz := TRUE;
              if ( (cc = ';') and (cc0 = 'Y') ) then
              begin
                k := 0;
                while ( TRUE ) do
                begin
                  cc1 := ucpInBuff[uipLines[uiI] + 2 + stri + k];
                  if ( not ((#$030 <= cc1) and (cc1 <= #$039)) ) then
                    break
                  else
                    Inc(k);
                end;
                stri := stri + k + 2;
                cc := ucpInBuff[uipLines[uiI] + stri];
                cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                OutChar(';');
                OutChar('Y');
                StrFmt(b, PChar('%d'), [CurrRow + CurRow - Sections[SectionIndex].BeginR]);
                k := 0;
                while ( b[k] > #0 ) do
                begin
                  OutChar(b[k]);
                  Inc(k);
                end;
                zz := TRUE;
              end;
              //
              if ( (cc = ';') and (cc0 = 'R') ) then
              begin
                k := 0;
                while ( TRUE ) do
                begin
                  cc1 := ucpInBuff[uipLines[uiI] + 2 + stri + k];
                  if ( not ((#$030 <= cc1) and (cc1 <= #$039)) ) then
                    break
                  else
                    Inc(k);
                end;
                stri := stri + k + 2;
                cc := ucpInBuff[uipLines[uiI] + stri];
                cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                OutChar(';');
                OutChar('R');
                StrFmt(b, PChar('%d'), [CurrRow + CurRow - Sections[SectionIndex].BeginR]);
                k := 0;
                while ( b[k] > #0 ) do
                begin
                  OutChar(b[k]);
                  Inc(k);
                end;
              end;
              //
              //Request by VALUE
              if ( (cc = ';') and (cc0 = 'K') ) then
              begin
                kNum := RowsPExact(ucpInBuff + uipLines[uiI] + stri + 2);
                if ( kNum <> 0 ) then
                begin
                  k := 0;
                  if ( kNum < 0 ) then k := 1;
                  while ( TRUE ) do
                  begin
                    cc1 := ucpInBuff[uipLines[uiI] + 2 + stri + k];
                    if ( not ((#$030 <= cc1) and (cc1 <= #$039)) ) then
                      break
                    else
                      Inc(k);
                  end;
                  RequestStr := '';
                  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, kNum, SECTION_DATA_REQUEST_BY_VALUE);
                  LenRequestStr := Length(RequestStr);
                  if ( LenRequestStr > 0 ) then
                  begin
                    OutChar(';');
                    OutChar('K');
                    i := 1;
                    while ( i <= LenRequestStr ) do
                    begin
                      OutChar(RequestStr[i]);
                      Inc(i);
                    end;
                  end;
                  stri := stri + k + 2;
                  cc := ucpInBuff[uipLines[uiI] + stri];
                  cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                end;
              end;
              //Request by number
              if ( cc = CharByNum ) then    //REQUEST_DATA_BY_NUM_SYMBOL
              begin
                //Foword 4 sign
                a0 := ucpInBuff[uipLines[uiI] + stri + 1];
                a1 := ucpInBuff[uipLines[uiI] + stri + 2];
                a2 := ucpInBuff[uipLines[uiI] + stri + 3];
                a3 := ucpInBuff[uipLines[uiI] + stri + 4];
                if ( ((#$030 <= a0) and (a0 <= #$039)) and ((#$030 <= a1) and (a1 <= #$039)) and ((#$030 <= a2) and (a2 <= #$039)) and ((#$030 <= a3) and (a3 <= #$039)) ) then
                begin
                  uiDataIndex := (Ord(a0) - Ord(#$030)) * 1000 + (Ord(a1) - Ord(#$030)) * 100 + (Ord(a2) - Ord(#$030)) * 10 + (Ord(a3) - Ord(#$030));
                  if (uiDataIndex > 0) then //Begin with 1  !!!!
                  begin
                    RequestStr := '';
                    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, uiDataIndex, SECTION_DATA_REQUEST_BY_NUM);
                    LenRequestStr := Length(RequestStr);
                    if ( LenRequestStr > 0 ) then
                    begin
                      i := 1;
                      while ( i <= LenRequestStr ) do
                      begin
                        OutChar(RequestStr[i]);
                        Inc(i);
                      end;
                    end;
                    stri := stri + 5;
                    cc := ucpInBuff[uipLines[uiI] + stri];
                    cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                  end;
                end;
              end;
              //Request by name
              if ( cc = CharByName ) then    //REQUEST_DATA_BY_NAME_SYMBOL
              begin
                cFieldName := '';
                cJ := FALSE;
                for j := 1 to MAX_LABEL_NAME_LEGTH do
                begin
                  cI := ucpInBuff[uipLines[uiI] + stri + j];
                  if ( cI = CharByName ) then
                  begin
                    cJ := TRUE;
                    break;
                  end;
                  cFieldName := cFieldName + cI;
                end;
                if ( cJ ) then  //if found
                begin
                  RequestStr := '';
                  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, Integer(Pchar(cFieldName)), SECTION_DATA_REQUEST_BY_NAME);
                  LenRequestStr := Length(RequestStr);
                  if ( LenRequestStr > 0 ) then
                  begin
                    i := 1;
                    while ( i <= LenRequestStr ) do
                    begin
                      OutChar(RequestStr[i]);
                      Inc(i);
                    end;
                  end;
                  stri := stri + j + 1;
                  cc := ucpInBuff[uipLines[uiI] + stri];
                  cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                end;
              end;
              if ( cc = #$0D ) then break;
              OutChar(cc);
              Inc(stri);
              cc := ucpInBuff[uipLines[uiI] + stri];
              cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
            end;
            OutChar(#$0D);
            OutChar(#$0A);
          end;
          //

          /////////////////////////
          //Request by cell
          /////////////////////////
          if ( zz ) then
          begin
            stDataRq.iTypeDataRequest := SECTION_DATA_REQUEST_BY_CELL;
            stDataRq.CurrCell.iRow := CurrRow + CurRow - Sections[SectionIndex].BeginR;
            stDataRq.CurrCell.iCol := CurCol;
            stDataRq.BlankCell.iRow := CurRow;
            stDataRq.BlankCell.iCol := CurCol;

            RequestStr := '';
            if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, Integer(@stDataRq), SECTION_DATA_REQUEST_BY_CELL);
            LenRequestStr := Length(RequestStr);
            if ( LenRequestStr > 0 ) then
            begin
              i := 1;
              while ( i <= LenRequestStr ) do
              begin
                OutChar(RequestStr[i]);
                Inc(i);
              end;
            end;

          end;
          //
        end;
        CurrRow := CurrRow + (Sections[SectionIndex].EndR - Sections[SectionIndex].BeginR + 1);
        if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_END);
      end;
    end;
    //
  finally
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_COMPLIT);
    FCurrentSectionNum := OldInd;
    FCurrentSection := OldName;
  end;
end;

procedure TERpt._OutSectionHorizontaly(const bDefOut: Boolean; const SectionIndex: Integer);
var
  uiI, uiJ, uiDataIndex, i, j, stri, k: Integer;
  cI, cc, cc0, cc1, a0, a1, a2, a3: Char;
  yy, zz, cJ: Boolean;
  CurCol: Integer;
  CurRow: Integer;
  iMin, iMax, iWidth, WidthR: Integer;
  b: array [0..19] of char;
  kNum: Integer;
  LenRequestStr: Integer;
  OldInd: Integer;
  OldName: String;
begin
  CurCol := 1;
  CurRow := 1;
  OldInd := FCurrentSectionNum;
  OldName := FCurrentSection;
  FCurrentSection := SectionsH[SectionIndex].Name;
  FCurrentSectionNum := SectionIndex;
  try
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_BEGIN);
    if SectionsH[SectionIndex].ucUsed then
    begin
      bCheck := bDefOut;
      if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_CHECK);
      if SectionIndex = 0 then
      begin
        //
        for uiI := 0 to uiInLines - 1 do
        begin
          cc := ucpInBuff[uipLines[uiI]];
          if ( (cc <> 'F') and (cc <> 'C') and (cc <> 'E') ) then
          begin
            stri := 0;
            while ( cc <> #$0D ) do
            begin
              OutChar(cc);
              Inc(stri);
              cc := ucpInBuff[uipLines[uiI] + stri];
            end;
            OutChar(#$0D);
            OutChar(#$0A);
          end;
        end;
        //
        bCheck := false;
      end;
      if ( SectionIndex = 12 ) then
      begin
        //
        OutChar('E');
        OutChar(#$0D);
        OutChar(#$0A);
        //
        bCheck := false;
      end;
      if ( bCheck ) then
      begin
        for uiI:=0 to uiInLines -1 do
        begin
          //
          yy := false;
          cc := ucpInBuff[uipLines[uiI]];
          cc0 := ucpInBuff[uipLines[uiI] + 1];
          cc1 := ucpInBuff[uipLines[uiI] + 2];
          if ( ((cc = 'F') or (cc = 'C')) and not ((cc0 = ';') and (cc1 = 'W')) ) then
          begin
            zz := false;
            stri := 0;
            cc := ucpInBuff[uipLines[uiI]];
            cc0 := ucpInBuff[uipLines[uiI] + 1];
            while ( cc <> #$0D ) do
            begin
              if ( ((cc = ';') and (cc0 = 'Y')) ) then
              begin
                CurRow := RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
                OutChar('F');
                OutChar(';');
                OutChar('Y');
                StrFmt(b, pChar('%d'), [CurRow]);
                k := 0;
                while ( b[k] <> #0 ) do
                begin
                  OutChar(b[k]);
                  Inc(k);
                end;
                OutChar(#$0D);
                OutChar(#$0A);
              end;
              if ( ((cc = ';') and (cc0 = 'X')) ) then
              begin
                CurCol := RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
                zz := TRUE;
              end;
              Inc(stri);
              cc := ucpInBuff[uipLines[uiI] + stri];
              cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
            end;
            if ( ( SectionsH[SectionIndex].BeginR <= CurCol ) and ( CurCol <= SectionsH[SectionIndex].EndR ) ) then
            begin
              yy := TRUE;
              if ( zz ) then
              begin
                for uiJ := 0 to uiInWidths - 1 do
                begin
                  WidthR := ParseWidth(ucpInBuff + uipLines[uipWidths[uiJ]] + 3, iMin, iMax, iWidth);
                  if ( (iMin <= CurCol) and (CurCol <=iMax) ) then
                  begin
                    OutChar('F');
                    OutChar(';');
                    OutChar('W');
                    WidthR := CurrCol + CurCol - SectionsH[SectionIndex].BeginR;
                    StrFmt(b, pChar('%d %d %d'), [WidthR, WidthR, iWidth]);
                    k := 0;
                    while ( b[k] <> #0 ) do
                    begin
                      OutChar(b[k]);
                      Inc(k);
                    end;
                    OutChar(#$0D);
                    OutChar(#$0A);
                  end;
                end;
              end;
            end;
          end;
          //
          zz := FALSE;
          if ( yy ) then
          begin
            stri := 0;
            cc := ucpInBuff[uipLines[uiI]];
            cc0 := ucpInBuff[uipLines[uiI] + 1];
            while ( cc <> #$0D ) do
            begin
              if ( (cc = ';') and (cc0 = 'Y') ) then zz := TRUE;
              if ( (cc = ';') and (cc0 = 'X') ) then
              begin
                k := 0;
                while ( TRUE ) do
                begin
                  cc1 := ucpInBuff[uipLines[uiI] + 2 + stri + k];
                  if ( not ((#$030 <= cc1) and (cc1 <= #$039)) ) then
                    break
                  else
                    Inc(k);
                end;
                stri := stri + k + 2;
                cc := ucpInBuff[uipLines[uiI] + stri];
                cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                OutChar(';');
                OutChar('X');
                StrFmt(b, pChar('%d'), [CurrCol + CurCol - SectionsH[SectionIndex].BeginR]);
                k := 0;
                while ( b[k] <> #0 ) do
                begin
                  OutChar(b[k]);
                  Inc(k);
                end;
                zz := TRUE;
              end;
              //Request by VALUE
              if ( (cc = ';') and (cc0 = 'K') ) then
              begin
                kNum := RowsPExact(ucpInBuff + uipLines[uiI] + stri + 2);
                if ( kNum <> 0 ) then
                begin
                  k := 0;
                  if ( kNum < 0 ) then k := 1;
                  while ( TRUE ) do
                  begin
                    cc1 := ucpInBuff[uipLines[uiI] + 2 + stri + k];
                    if ( not ((#$030 <= cc1) and (cc1 <= #$039)) ) then
                      break
                    else
                      Inc(k);
                  end;
                  RequestStr := '';
                  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, kNum, SECTION_DATA_REQUEST_BY_VALUE);
                  LenRequestStr := Length(RequestStr);
                  if ( LenRequestStr > 0 ) then
                  begin
                    OutChar(';');
                    OutChar('K');
                    i := 1;
                    while ( i <= LenRequestStr ) do
                    begin
                      OutChar(RequestStr[i]);
                      Inc(i);
                    end;
                  end;
                  stri := stri + k + 2;
                  cc := ucpInBuff[uipLines[uiI] + stri];
                  cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                end;
              end;
              //Request by number
              if ( cc = CharByNum ) then    //REQUEST_DATA_BY_NUM_SYMBOL
              begin
                //Foword 4 sign
                a0 := ucpInBuff[uipLines[uiI] + stri + 1];
                a1 := ucpInBuff[uipLines[uiI] + stri + 2];
                a2 := ucpInBuff[uipLines[uiI] + stri + 3];
                a3 := ucpInBuff[uipLines[uiI] + stri + 4];
                if ( ((#$030 <= a0) and (a0 <= #$039)) and ((#$030 <= a1) and (a1 <= #$039)) and ((#$030 <= a2) and (a2 <= #$039)) and ((#$030 <= a3) and (a3 <= #$039)) ) then
                begin
                  uiDataIndex := (Ord(a0) - Ord(#$030)) * 1000 + (Ord(a1) - Ord(#$030)) * 100 + (Ord(a2) - Ord(#$030)) * 10 + (Ord(a3) - Ord(#$030));
                  if (uiDataIndex > 0) then //Begin with 1  !!!!
                  begin
                    RequestStr := '';
                    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, uiDataIndex, SECTION_DATA_REQUEST_BY_NUM);
                    LenRequestStr := Length(RequestStr);
                    if ( LenRequestStr > 0 ) then
                    begin
                      i := 1;
                      while ( i <= LenRequestStr ) do
                      begin
                        OutChar(RequestStr[i]);
                        Inc(i);
                      end;
                    end;
                    stri := stri + 5;
                    cc := ucpInBuff[uipLines[uiI] + stri];
                    cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                  end;
                end;
              end;
              //Request by name
              if ( cc = CharByName ) then    //REQUEST_DATA_BY_NAME_SYMBOL
              begin
                cFieldName := '';
                cJ := FALSE;
                for j := 1 to MAX_LABEL_NAME_LEGTH do
                begin
                  cI := ucpInBuff[uipLines[uiI] + stri + j];
                  if ( cI = CharByName ) then
                  begin
                    cJ := TRUE;
                    break;
                  end;
                  cFieldName := cFieldName + cI;
                end;
                if ( cJ ) then  //if found
                begin
                  RequestStr := '';
                  if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, Integer(Pchar(cFieldName)), SECTION_DATA_REQUEST_BY_NAME);
                  LenRequestStr := Length(RequestStr);
                  if ( LenRequestStr > 0 ) then
                  begin
                    i := 1;
                    while ( i <= LenRequestStr ) do
                    begin
                      OutChar(RequestStr[i]);
                      Inc(i);
                    end;
                  end;
                  stri := stri + j + 1;
                  cc := ucpInBuff[uipLines[uiI] + stri];
                  cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
                end;
              end;
              if ( cc = #$0D ) then break;
              OutChar(cc);
              Inc(stri);
              cc := ucpInBuff[uipLines[uiI] + stri];
              cc0 := ucpInBuff[uipLines[uiI] + stri + 1];
            end;
            OutChar(#$0D);
            OutChar(#$0A);
          end;
          //

          /////////////////////////
          //Request by cell
          /////////////////////////
          if ( zz ) then
          begin
            stDataRq.iTypeDataRequest := SECTION_DATA_REQUEST_BY_CELL;
            stDataRq.CurrCell.iRow := CurRow;
            stDataRq.CurrCell.iCol := CurrCol + CurCol - SectionsH[SectionIndex].BeginR;
            stDataRq.BlankCell.iRow := CurRow;
            stDataRq.BlankCell.iCol := CurCol;

            RequestStr := '';
            if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, Integer(@stDataRq), SECTION_DATA_REQUEST_BY_CELL);
            LenRequestStr := Length(RequestStr);
            if ( LenRequestStr > 0 ) then
            begin
              i := 1;
              while ( i <= LenRequestStr ) do
              begin
                OutChar(RequestStr[i]);
                Inc(i);
              end;
            end;
          end;
          //

        end;
        CurrCol := CurrCol + SectionsH[SectionIndex].EndR - SectionsH[SectionIndex].BeginR + 1;
        if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_END);
      end;
    end;
  finally
    if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, NEW_SECTION_START + SectionIndex, 0, SECTION_COMPLIT);
    FCurrentSectionNum := OldInd;
    FCurrentSection := OldName;
  end;
end;

procedure TERpt._PrepareSection(var cSection: Section; const cSectionName: ShortString; const SectionIndex: Integer);
var
  fppP: FoundPar;
  ExSectionName: String;
  uiI: Integer;
  LenN: Integer;
  Address: String;
  TopLeft, BottomRight: TExcelCell;
begin
  cSection.Name := cSectionName;
  ExSectionName := 'NN;N' + cSectionName + ';E';
  fppP.bF := false;
  uiI := 0;
  LenN := Length(ExSectionName);
  while uiI < uiInLines do
  begin
    if StrLComp(ucpInBuff + uipLines[uiI], pChar(ExSectionName), LenN) = 0 then
    begin
      fppP.bF := true;
      fppP.uiP := uiI;
      break;
    end;
    Inc(uiI);
  end;
  if fppP.bF then
  begin

    SetString(Address, ucpInBuff + uipLines[fppP.uiP] + LenN, uipLines[fppP.uiP + 1] - (uipLines[fppP.uiP] + LenN) - 2);
    TExcelDDEClient.ParseSelEntry(Address, TopLeft, BottomRight);
    if FTypeDiraction = tdVerticaly then begin
      cSection.BeginR := TopLeft.Row;
      cSection.EndR := BottomRight.Row;
    end else begin
      cSection.BeginR := TopLeft.Col;
      cSection.EndR := BottomRight.Col;
    end;

    {
    fppP.bF := false;
    uiI := uipLines[uiI] + LenN;
    while true do
    begin
      if ucpInBuff[uiI] = ':' then
      begin
        fppP.bF := true;
        break;
      end;
      if ucpInBuff[uiI] = Char($0D) then break;
      Inc(uiI);
    end;
    if fppP.bF then
    begin
      cSection.BeginR := RowsP(ucpInBuff + uipLines[fppP.uiP] + LenN);
      cSection.EndR := RowsP(ucpInBuff + uiI + 1);
    end else begin
      cSection.EndR := RowsP(ucpInBuff + uipLines[fppP.uiP] + LenN);
      cSection.BeginR := cSection.EndR;
    end;
    }

    cSection.ucUsed := true;
  end else
    cSection.ucUsed := false;
end;

function TERpt.RowsP(RegionD: pChar): Integer;
var
  i, j, k: Integer;
  a: array[0..9] of Char;
  cc: Char;
  Negative: Char;
begin
  for i := 0 to 9 do a[i] := #0;
  i := 0;
  Negative := #0;
  if RegionD[0] = '-' then
  begin
    i := 1;
    Negative := #1;
  end;
  k := 0;
  while true do
  begin
    cc := RegionD[i];
    if ( #$30 <= cc ) and ( cc <= #$39 ) then
    begin
      a[k] := cc;
      Inc(k);
    end;
    if ( cc = ' ' ) then break;
    if ( cc = ':' ) then break;
    if ( cc = ';' ) then break;
    if ( cc = #$0D ) then break;
    Inc(i);
  end;
  j := 0;
  i := 0;
  while a[i] <> #0 do
  begin
    j := j +  Ord(Ord(a[k - 1 - i]) - Ord(#$30)) * pow10(i);
    Inc(i);
  end;
  if Negative = #1 then
    Result := -j
  else
    Result := j;
end;

function TERpt.RowsPExact(RegionD: pChar): Integer;
var
  i, j, k: Integer;
  a: array[0..9] of Char;
  cc: Char;
  Negative: Char;
begin
  for i := 0 to 9 do a[i] := #0;
  i := 0;
  Negative := #0;
  if RegionD[0] = '-' then
  begin
    i := 1;
    Negative := #1;
  end;
  k := 0;
  while true do
  begin
    cc := RegionD[i];
    if ( #$30 <= cc ) and ( cc <= #$39 ) then
    begin
      a[k] := cc;
      Inc(k);
    end else break;
    if ( cc = ' ' ) then break;
    if ( cc = ':' ) then break;
    if ( cc = ';' ) then break;
    if ( cc = #$0D ) then break;
    Inc(i);
  end;
  j := 0;
  i := 0;
  while a[i] <> #0 do
  begin
    j := j +  Ord(Ord(a[k - 1 - i]) - Ord(#$30)) * pow10(i);
    Inc(i);
  end;
  if Negative = #1 then
    Result := -j
  else
    Result := j;
end;

function TERpt.pow10(i: Integer): Integer;
begin
  Result := 1;
  while i <> 0 do
  begin
    Result := Result * 10;
    Dec(i);
  end;
end;

procedure TERpt.OutChar(cc: Char);
var
  uiRW: Integer;
begin
  ucpOutBuff[uiOutP] := cc;
  Inc(uiOutP);
  if uiOutP = FILE_BUFFER then
  begin
    if not Assigned(FOutStream) then
      uiRW := FileWrite(fhOutBlank, ucpOutBuff^, FILE_BUFFER)
    else
      uiRW := FOutStream.Write(ucpOutBuff^, FILE_BUFFER);
    uiOutP := 0;
    if FILE_BUFFER <> uiRW then
    begin
      if Assigned(FOnSylkReportMessage) then FOnSylkReportMessage(self, WM_REP_WRITE_ERROR, 0, 0);
      raise Exception.Create('WRITE_EXCEPTION');
    end;
  end;
end;

function TERpt.ParseWidth(RegionD: PChar; var iMin, iMax, iWidth: Integer): Integer;
var
  i, j: Integer;
  cc: Char;
begin
  i := 0;
  j := 0;
  iMin := RowsP(RegionD);
  while ( TRUE ) do
  begin
    cc := RegionD[i];
    if ( cc = ' ' ) then
    begin
      if ( j = 0 ) then iMax := RowsP(RegionD + i + 1);
      if ( j = 1 ) then iWidth := RowsP(RegionD + i + 1);
      Inc(j);
    end;
    Inc(i);
    if ( cc = #$0D ) then break;
  end;
  Result := i;
end;

procedure TERpt.SeekLastNN(var fppP: FoundPar);
var
  uiI: Integer;
begin
  fppP.bF := FALSE;
  for uiI := 0 to uiInLines - 1 do
  begin
    if ( StrLComp(ucpInBuff + uipLines[uiI], pChar('NN;N'), 4) = 0 ) then
    begin
      if ( not fppP.bF )  then
      begin
        fppP.bF := TRUE;
        fppP.uiP := uiI;
      end;
      uiDetail := uiI + 1;
    end;
  end;
end;

procedure TERpt.CloseSections;
var
  i: Integer;
begin
  for i := 0 to MAX_SECTION_NUM - 1 do
  begin
    Sections[i].ucUsed := false;
    SectionsH[i].ucUsed := false;
  end;
end;

procedure TERpt.OutHorizontalySectionByNum(SectionNum: Integer);
begin
  _OutSectionHorizontaly(TRUE, SectionNum);
end;

procedure TERpt.OutSectionByNum(SectionNum: Integer);
begin
  _OutSection(TRUE, SectionNum);
end;

destructor TERpt.Destroy;
begin
  SetLength(uipWidths, 0);
  SetLength(uipLines, 0);
  StrDispose(ucpInBuff);
  StrDispose(ucpOutBuff);
  inherited Destroy;
end;

{ TSylkStream }

procedure TSylkStream.BiDirectionExecute;
begin
  SetPropertys;
  _Sylk.BiDirectionExecute;
end;

procedure TSylkStream.BiDirectionResume;
begin
  SetPropertys;
  _Sylk.BiDirectionResume;
end;

constructor TSylkStream.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  _Sylk := TERpt.Create;
  CharByNum := _Sylk.CharByNum;
  CharByName := _Sylk.CharByName;
  _Sylk.OnSylkReportMessage := DispatchSmartMessages;
end;

destructor TSylkStream.Destroy;
begin
  _Sylk.Destroy;
  inherited;
end;

procedure TSylkStream.DispatchSmartMessages(Sender: TObject; const iMessage, iW, iL: Integer);
var
  Msg: TMessage;
begin
  Msg.Msg := iMessage;
  Msg.Wparam := iW;
  Msg.Lparam := iL;
  case (iMessage) of

    WM_REP_START_REPORT:           MsgStartReport(Msg);
    WM_REP_END_REPORT:             MsgEndReport(Msg);

    WM_REP_MOVE:                   MsgReportMove(Msg);

    WM_REP_THREAD_ERROR:           MsgReportError(Msg);
    WM_REP_OPEN_ERROR:             MsgReportError(Msg);
    WM_REP_CREATE_ERROR:           MsgReportError(Msg);
    WM_REP_MEM_ERROR:              MsgReportError(Msg);
    WM_REP_READ_ERROR:             MsgReportError(Msg);
    WM_REP_SECTION_ERROR:          MsgReportError(Msg);
    WM_REP_WRITE_ERROR:            MsgReportError(Msg);
    WM_REP_SECTION_PREPARE:
      if Assigned(OnSectionPrepare) then OnSectionPrepare(self);

  else
    if iMessage >= WM_REP_RTF_HEADER then
      SectionHandler( Msg,
                      OnSectionBegin,
                      OnSectionCheck,
                      OnSectionDataRequestByCell,
                      OnSectionDataRequestByVal,
                      OnSectionDataRequestByNum,
                      OnSectionDataRequestByName,
                      OnSectionEnd,
                      OnSectionComplit);
  end;
end;

function TSylkStream.GetCurrentSection: String;
begin
  Result := _Sylk.FCurrentSection;
end;

function TSylkStream.GetCurrentSectionNum: Integer;
begin
  Result := _Sylk.FCurrentSectionNum;
end;

function TSylkStream.GetTypeDiraction: TTtypeDiraction;
begin
  Result := _Sylk.TypeDiraction;
end;

function TSylkStream.GetTypeReport: TTtypeSylkReport;
begin
  Result := _Sylk.TypeReport;
end;

procedure TSylkStream.MsgEndReport(var Msg: TMessage);
begin
  if Assigned(OnEndReport) then OnEndReport(self);
end;

procedure TSylkStream.MsgReportError(var Msg: TMessage);
begin
  case Msg.Msg of
    WM_REP_THREAD_ERROR:    cS := 'Thread Error';
    WM_REP_OPEN_ERROR:      cS := 'Open Error';
    WM_REP_CREATE_ERROR:    cS := 'Create Error';
    WM_REP_MEM_ERROR:       cS := 'Memory Error';
    WM_REP_READ_ERROR:      cS := 'Read Error';
    WM_REP_SECTION_ERROR:   cS := 'Section Error';
    WM_REP_WRITE_ERROR:     cS := 'Write Error';
  end;
  if Assigned(OnReportError) then OnReportError(self, Msg, cS);
end;

procedure TSylkStream.MsgReportMove(var Msg: TMessage);
begin
  bCheck := true;
  if Msg.LParam = MOVE_TOP then
  begin
    if Assigned(OnMoveTop) then OnMoveTop(self, bCheck);
  end
  else
  begin
    if Msg.LParam = MOVE_NEXT then if Assigned(OnMoveNext) then OnMoveNext(self, bCheck);
  end;
  _Sylk.bCheck := bCheck;
end;

procedure TSylkStream.MsgStartReport(var Msg: TMessage);
begin
  if Assigned(OnStartReport) then OnStartReport(self);
end;

procedure TSylkStream.OutHorizontalySection(SectionName: ShortString);
begin
  _Sylk.OutHorizontalySection(SectionName);
end;

procedure TSylkStream.OutHorizontalySectionByNum(SectionNum: Integer);
begin
  _Sylk.OutHorizontalySectionByNum(SectionNum);
end;

procedure TSylkStream.OutSection(SectionName: ShortString);
begin
  _Sylk.OutSection(SectionName);
end;

procedure TSylkStream.OutSectionByNum(SectionNum: Integer);
begin
  _Sylk.OutSectionByNum(SectionNum);
end;

function TSylkStream.PrepareHorizontalySection(const SectionName: ShortString): Integer;
begin
  Result := _Sylk.PrepareHorizontalySection(SectionName);
end;

function TSylkStream.PrepareSection(const SectionName: ShortString): Integer;
begin
  Result := _Sylk.PrepareSection(SectionName);
end;

procedure TSylkStream.ReportExecute;
begin
  SetPropertys;
  _Sylk.ReportExecute;
end;

procedure TSylkStream.ReportHorizontalyExecute;
begin
  SetPropertys;
  _Sylk.ReportHorizontalyExecute;
end;

procedure TSylkStream.ReportHorizontalyResume;
begin
  SetPropertys;
  _Sylk.ReportHorizontalyResume;
end;

procedure TSylkStream.ReportResume;
begin
  SetPropertys;
  _Sylk.ReportResume;
end;

procedure TSylkStream.SectionHandler(var Msg: TMessage; e0: TNotifyEvent;
  e1: TOnCheck; e5: TOnSectionDataRequestByCell;
  e6: TOnSectionDataRequestByVal; e2: TOnSectionDataRequestByNum;
  e3: TOnSectionDataRequestByName; e4: TNotifyEvent; e7: TNotifyEvent);
begin
  cS := '';
  bCheck := _Sylk.bCheck;
  case Msg.LParam of
    SECTION_DATA_REQUEST_BY_CELL:
      begin
        if Assigned(e5) then e5(self, pDataRq(Msg.WParam)^)
          else if Assigned(OnSectionDataRequestByCell) then OnSectionDataRequestByCell(self, pDataRq(Msg.WParam)^);
        _Sylk.RequestStr := cS;
      end;
    SECTION_DATA_REQUEST_BY_VALUE:
      begin
        if Assigned(e6) then e6(self, Msg.WParam, cS)
          else if Assigned(OnSectionDataRequestByVal) then OnSectionDataRequestByVal(self, Msg.WParam, cS);
        _Sylk.RequestStr := cS;
      end;
    SECTION_DATA_REQUEST_BY_NUM:
      begin
        if Assigned(e2) then e2(self, Msg.WParam, cS)
          else if Assigned(OnSectionDataRequestByNum) then OnSectionDataRequestByNum(self, Msg.WParam, cS);
        _Sylk.RequestStr := cS;
      end;
    SECTION_DATA_REQUEST_BY_NAME:
      begin
        cFieldName := String(pChar(Msg.WParam));
        if Assigned(e3) then e3(self, cFieldName, cS)
          else if Assigned(OnSectionDataRequestByName) then OnSectionDataRequestByName(self, cFieldName, cS);
        _Sylk.RequestStr := cS;
      end;
    SECTION_CHECK:
      begin
        if Assigned(e1) then e1(self, bCheck)
          else if Assigned(OnSectionCheck) then OnSectionCheck(self, bCheck);
        _Sylk.bCheck := bCheck;   //print section with this record or not
      end;
    SECTION_BEGIN: if Assigned(e0) then e0(self) else if Assigned(OnSectionBegin) then OnSectionBegin(self);
    SECTION_END: if Assigned(e4) then e4(self) else if Assigned(OnSectionEnd) then OnSectionEnd(self);
    SECTION_COMPLIT: if Assigned(e7) then e7(self) else if Assigned(OnSectionComplit) then OnSectionComplit(self);
  else
  end;
end;

procedure TSylkStream.SetPropertys;
begin
  _Sylk.CharByNum := CharByNum;
  _Sylk.CharByName := CharByName;
  _Sylk.InputBlank := InputBlank;
  _Sylk.OutputBlank := OutputBlank;
  _Sylk.OutStream := OutStream;
end;

end.
